DECLARE
   V_CDSEQUENCIAL VARCHAR2(20) NULL;
BEGIN
    /*REGISTRANDO A PROCEDURE PARA O AGENDADOR DE EVENTOS*/
    SELECT COUNT(*)
    INTO   V_CDSEQUENCIAL
    FROM   EVENTOAEV 
    WHERE  NMOBJBDEVEN = 'ETL_FATUINVOICE';
    
    IF V_CDSEQUENCIAL = 0 THEN     --> S ADICIONA A PROCEDURE SE ELA NO EXISTIR AINDA NO CADASTRO
        BEGIN
        
            SELECT LPAD(NVL(MAX(CDEVENTOAEV)+1,0),10,'0')
            INTO   V_CDSEQUENCIAL
            FROM   EVENTOAEV;
        
            INSERT INTO EVENTOAEV 
            (CDEVENTOAEV, NMEVENTOAEV, IDTPEVENAEV, CDOPERINCL, DTINCLEVEN, NMOBJBDEVEN)
            VALUES
            (V_CDSEQUENCIAL,'ETL Faturamento Comissaria','STP',NULL,SYSDATE,'ETLFATUINVOICE');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (V_CDSEQUENCIAL,'P_DTINI','D','E','Data Inicial','N',0,'01');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (V_CDSEQUENCIAL,'P_DTFINA','D','E','Data Final','N',0,'02');
        
            COMMIT;
        EXCEPTION
           WHEN OTHERS THEN
              RAISE_APPLICATION_ERROR (-20001,'Falha no cadastro de eventos agendveis.');
        END;
    END IF;
END;
/

/*Cadastrando os fatos e dimenses para o DW*/
BEGIN
   CRIA_FATOS('ETLFATUINVOICE', 'VRFATUETLFAC',   'Faturamento Comissaria', 'Comissaria');
   CRIA_FATOS('ETLFATUINVOICE', 'VRMERCETLFAC',   'Valor de Mercadoria',    'Comissaria');
   CRIA_FATOS('ETLFATUINVOICE', 'VRSERVETLFAC',   'Valor do Servio',       'Comissaria');
   CRIA_FATOS('ETLFATUINVOICE', 'VRTXARETLFAC',   'Taxa do Aeroporto',      'Comissaria');
   CRIA_FATOS('ETLFATUINVOICE', 'VRDESCETLFAC',   'Desconto',               'Comissaria');
   CRIA_FATOS('ETLFATUINVOICE', 'VRACREETLFAC',   'Acrscimo',              'Comissaria');
   CRIA_FATOS('ETLFATUINVOICE', 'VRIMPOETLFAC',   'Impostos',               'Comissaria');   
   
   CRIA_DIME('ETLFATUINVOICE',  'CDFILIAL',   'Filial',   'FILIAL',   'CDFILIAL',   'NMFILIAL',   NULL); 
   CRIA_DIME('ETLFATUINVOICE',  'CDEMPRESA',  'Empresa',  'EMPRESA',  'CDEMPRESA',  'NMEMPRESA',  NULL); 
   CRIA_DIME('ETLFATUINVOICE',  'CDPAIS',     'Pas',     'PAIS',     'CDPAIS',     'NMPAIS',     NULL); 
   CRIA_DIME('ETLFATUINVOICE',  'CDAREAGERE', 'Regional', 'AREAGERE', 'CDAREAGERE', 'NMAREAGERE', NULL);    
   CRIA_DIME('ETLFATUINVOICE',  'CDCLIENTE',  'Cliente',  'CLIENTE',  'CDCLIENTE',  'NMFANTCLIE', NULL);    
   CRIA_DIME('ETLFATUINVOICE',  'ANETLFAC',   'Ano',      NULL,       NULL,         NULL,         NULL);    
   CRIA_DIME('ETLFATUINVOICE',  'MEETLFAC',   'Ms',      NULL,       NULL,         NULL,         NULL);    
   
   COMMIT; 
END;
/